#include "excalibur.h"

unsigned short crcCompute(unsigned long *data_block, unsigned int nWords)
{
    unsigned long*  pointer;
    unsigned long   word;

	 word = nm_crc (0xFFFF, 1);  // initialise crc reg to 0xFFFF

    for (pointer = data_block; pointer < (data_block + nWords); pointer ++)
    {
		 word = nm_crc(*pointer, 0);
	 }

    return (word);

}   /* crcCompute() */



int main(void)
{
	#define CRC_ITERATIONS 5000

   unsigned short int crc_result;
	unsigned int outer_loop;
	unsigned int inner_loop;
	unsigned int led = 0;
	int start_time;
	int finish_time;

	np_pio *ledpio = na_led_pio;

	*(int*)(na_my_pwm_base +4) = 0x00;
	ledpio->np_piodata = led;

	printf("\n\nCalculating CRC with Custom Instruction\n");

	start_time = nr_timer_milliseconds();

	for (outer_loop = 1; outer_loop <= 7; outer_loop++)
	{
		led = led << 1;
		led++;
		ledpio->np_piodata = led;

		for (inner_loop = 1; inner_loop <= CRC_ITERATIONS; inner_loop = inner_loop + 7)
			crc_result = crcCompute((long*)na_boot_rom_base, na_boot_rom_size/4);

	}

	*(int*)(na_my_pwm_base +4) = 0xff;
	finish_time = nr_timer_milliseconds();

	printf ("\nCRC for Data Block = 0x%x.\n", crc_result);
	printf ("Calculation time for %d iterations is %dms\n",CRC_ITERATIONS, finish_time - start_time);



}
